#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var path = require("path");
var util_1 = require("./util");
var emiter_1 = require("./emiter");
var info_1 = require("./info");
var meow = require('meow');
var watchr = require('watchr');
var firstline = require('firstline');
var cli = meow("\n\tUsage\n\t  $ tsr [path]\n\n\tOptions\n      --watch, -w  watch the path for changes\n      --help, -h  show this help\n", {
    flags: {
        watch: {
            type: 'boolean',
            alias: 'w'
        }
    }
});
function emitComponent(fileName) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, _b, info, outName;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _b = (_a = /^(\s*\/\/\s*@ts\-react\s*)$/).test;
                    return [4 /*yield*/, firstline(fileName)];
                case 1:
                    if (!(_b.apply(_a, [_c.sent()]))) {
                        return [2 /*return*/];
                    }
                    info = info_1.extractInfo(fileName);
                    outName = path.parse(fileName).dir + "/" + path.parse(fileName).name + ".gen.tsx";
                    console.info(" - " + path.parse(fileName).name + " > " + outName);
                    fs.writeFileSync(outName, emiter_1.emitStatefull(info));
                    return [2 /*return*/];
            }
        });
    });
}
function listener(changeType, fullPath, currentStat, previousStat) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(changeType == 'update')) return [3 /*break*/, 2];
                    if (!(fullPath.indexOf('node_modules') === -1 && !fullPath.endsWith('.gen.tsx') && fullPath.endsWith('.tsx'))) return [3 /*break*/, 2];
                    return [4 /*yield*/, emitComponent(fullPath)];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    });
}
function next(err) {
    if (err)
        return console.error('watch failed on', err);
}
if (process.argv.length == 3 && (process.argv[2] == '-h' || process.argv[2] == '--help')) {
    cli.showHelp();
}
else {
    var startPath = null;
    if (cli.input.length > 0) {
        startPath = cli.input[0];
    }
    else {
        startPath = process.cwd();
        console.info("Using: " + startPath);
    }
    var stats = fs.lstatSync(startPath);
    if (!stats.isDirectory()) {
        console.info("Invalid directory: " + startPath);
    }
    else {
        console.info('Looking for files with "// @ts-react" annotation...');
        util_1.getTsReactFiles(startPath).forEach(function (fileName) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, emitComponent(fileName)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        if (cli.flags.watch || cli.flags.w) {
            console.info('Watch mode started...');
            var stalker_1 = watchr.open(startPath, listener, next);
            process.on('SIGTERM', function () {
                console.info('Stopping...');
                stalker_1.close();
            });
        }
    }
}
//# sourceMappingURL=cli.js.map