import { readdirSync } from 'fs';
import * as path from 'path';

const firstline = require('firstline');

export function getTsReactFiles(dir: string, filelist: string[] = []) {
    readdirSync(dir).forEach(async file => {
        const dirFile = path.join(dir, file);
        try {
            filelist = getTsReactFiles(dirFile, filelist);
        }
        catch (err) {
            if (err.code === 'ENOTDIR' || err.code === 'EBUSY') {
                if (dirFile.indexOf('node_modules') === -1 && dirFile.endsWith('.tsx'))
                    filelist = [...filelist, dirFile];
            }
            else throw err;
        }
    });
    return filelist;
}
